﻿Imports System
Imports System.IO.Ports
Imports System.Text

Public Class Form1


    '起動時
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        TextBox1.Enabled = False '送信テキスト
        TextBox2.Enabled = False '受信テキスト
        Button2.Enabled = False '送信ボタン
        CheckBox1.Enabled = False

    End Sub


    Private Sub Form1_Shown(sender As Object, e As System.EventArgs) Handles Me.Shown
        '利用可能なシリアルポート名の配列を取得する.
        Dim PortList As String()
        PortList = SerialPort.GetPortNames()

        ComboBox1.Items.Clear()

        'シリアルポート名をコンボボックスにセットする.
        Dim PortName As String
        For Each PortName In PortList
            ComboBox1.Items.Add(PortName)
        Next PortName

        If ComboBox1.Items.Count > 0 Then
            ComboBox1.SelectedIndex = 0 '先頭選択
        End If

        '利用可能なポートに前回設定していたポートが含まれている場合はそれを設定する
        For Each PortName In PortList
            If PortName = My.Settings.ComStr Then
                ComboBox1.Text = My.Settings.ComStr
            End If
        Next PortName


        '
        '通信速度設定
        '
        If My.Settings.BpsStr = "" Then
            TextBox3.Text = "115200"
            TextBox3.Focus() '通信測度テキスト-フォーカス
        Else
            '前回値を設定
            TextBox3.Text = My.Settings.BpsStr
            Button1.Focus() '接続ボタン-フォーカス
        End If

    End Sub


    '×ボタン
    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'シリアルポートをオープンしている場合、クローズする.
        If SerialPort1.IsOpen Then
            SerialPort1.Close()
        End If

        'COMポート番号および通信速度設定値保存
        My.Settings.ComStr = ComboBox1.Text
        My.Settings.BpsStr = TextBox3.Text
        My.Settings.Save()

    End Sub


    'RS232シリアル受信割込み
    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived

        'シリアルポートをオープンしていない場合、処理を行わない.
        If SerialPort1.IsOpen = False Then
            Return
        End If

        Try
            '受信データを読み込む.
            Dim recvStr As String
            recvStr = SerialPort1.ReadExisting()

            '受信したデータをテキストボックスに書き込む.
            Invoke(New Delegate_RcvDataToTextBox(AddressOf Me.RcvDataToTextBox), recvStr)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub


    '受信文字列表示（デリゲート使用）
    Private Delegate Sub Delegate_RcvDataToTextBox(data As String)
    Private Sub RcvDataToTextBox(data As String)

        '受信データをテキストボックスの最後に追記する.
        If IsNothing(data) = False Then
            TextBox2.AppendText(data) '受信データ追記
        End If
    End Sub


    '接続ボタン
    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click

        If SerialPort1.IsOpen = True Then

            'シリアルポートをクローズする.
            SerialPort1.Close()

            'ボタンの表示を[切断]から[接続]に変える.
            Button1.Text = "接続"

            ComboBox1.Enabled = True 'COM選択
            TextBox3.Enabled = True  '通信速度テキスト
            TextBox1.Enabled = False
            TextBox2.BackColor = System.Drawing.SystemColors.ButtonFace
            Button2.Enabled = False  '送信ボタン
            CheckBox1.Enabled = False
        Else

            '
            'シリアルポート 
            'COMポート,通信速度 ←可変
            '8bit,パリティなし,ストップ１ビット,フロー制御なし ←固定
            '

            'オープンするシリアルポートをコンボボックスから取り出す.
            SerialPort1.PortName = ComboBox1.SelectedItem.ToString()

            SerialPort1.BaudRate = TextBox3.Text

            'データビットをセットする. (データビット = 8ビット)
            SerialPort1.DataBits = 8

            'パリティビットをセットする. (パリティビット = なし)
            SerialPort1.Parity = Parity.None

            'ストップビットをセットする. (ストップビット = 1ビット)
            SerialPort1.StopBits = StopBits.One

            'フロー制御：ハンドシェイクなし
            SerialPort1.Handshake = Handshake.None

            Try
                'シリアルポートをオープンする.
                SerialPort1.Open()

                'ボタンの表示を[接続]から[切断]に変える.
                Button1.Text = "切断"

                ComboBox1.Enabled = False 'COM選択
                TextBox3.Enabled = False  '通信速度テキスト
                TextBox1.Enabled = True   '送信テキスト
                TextBox2.Enabled = True   '受信テキスト
                TextBox2.BackColor = Color.White
                Button2.Enabled = True    '送信ボタン
                CheckBox1.Enabled = True
                TextBox1.Text = ""        '送信テキスト-クリア
                TextBox2.Text = ""        '受信テキスト-クリア
                TextBox1.Focus()          '送信テキスト-フォーカス
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try

        End If

        If CheckBox1.Checked = True Then
            Button2.Enabled = False
        End If
    End Sub


    '送信ボタン
    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        SerialSend()
    End Sub

    '通信速度(bps) テキストボックス
    Private Sub TextBox3_KeyPress(sender As Object, e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox3.KeyPress
        '0～9と、バックスペース以外の時は、イベントをキャンセルする(DOBON様より)
        If (e.KeyChar < "0"c OrElse "9"c < e.KeyChar) AndAlso e.KeyChar <> ControlChars.Back Then
            e.Handled = True
        End If
    End Sub

    '“Enterキーで「送信」”チェックボックス
    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If CheckBox1.Checked = True Then
            Button2.Enabled = False   '送信ボタン
        Else
            Button2.Enabled = True
        End If

        TextBox1.Focus()
    End Sub


    '送信 テキストボックス
    Private Sub TextBox1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBox1.KeyDown
        '“Enterキーで「送信」”にチェックが入っていたら、Enterキーでシリアル送信。
        If CheckBox1.Checked = True And e.KeyCode = Keys.Enter Then
            SerialSend()
        End If
    End Sub


    Private Sub SerialSend()
        'シリアルポートをオープンしていない場合、処理を行わない.
        If SerialPort1.IsOpen = False Then
            Return
        End If

        'テキストボックスから、送信するテキストを取り出す.
        Dim sendStr As String
        sendStr = TextBox1.Text

        '送信するテキストがない場合、データ送信は行わない.
        If String.IsNullOrEmpty(sendStr) Then
            Return
        End If

        Try
            'シリアルポートからテキストを送信する.
            SerialPort1.Write(sendStr)

            '送信データを入力するテキストボックスをクリアする.
            TextBox1.Text = ""
            TextBox1.Focus() '送信テキスト-フォーカス
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub


End Class
